## GThreadedSocketService GThreadedSocketService — A threaded GSocketService |

## Synopsis

                        GThreadedSocketService;
    GSocketService *         g_threaded_socket_service_new  (int max_threads);

## Object Hierarchy

      GObject
       +----GSocketListener
             +----GSocketService
                   +----GThreadedSocketService

## Properties

      "max-threads"              gint                  : Read / Write / Construct Only

## Signals

      "run"                                            : Run Last

## Description

A GThreadedSocketService is a simple subclass of GSocketService that handles incoming connections by creating a worker thread and dispatching the connection to it by emitting the ::run signal in the new thread.

The signal handler may perform blocking IO and need not return until the connection is closed.

The service is implemented using a thread pool, so there is a limited amount of threads availible to serve incomming requests. The service automatically stops the GSocketService from accepting new connections when all threads are busy.

As with GSocketService, you may connect to "run", or subclass and override the default handler.

## Details

### GThreadedSocketService

    typedef struct _GThreadedSocketService GThreadedSocketService;

A helper class for handling accepting incomming connections in the glib mainloop and handling them in a thread.

Since 2.22

### g_threaded_socket_service_new ()

    GSocketService *         g_threaded_socket_service_new  (int max_threads);

Creates a new GThreadedSocketService with no listeners. Listeners must be added with `g_socket_service_add_listeners()`.

`max_threads` : | the maximal number of threads to execute concurrently handling incoming clients, -1 means no limit
Returns : | a new GSocketService.

Since 2.22

## Property Details

### The `"max-threads"` property

      "max-threads"              gint                  : Read / Write / Construct Only

The max number of threads handling clients for this service.

Allowed values: >= G_MAXULONG

Default value: 10

## Signal Details

### The `"run"` signal

    gboolean            user_function                      (GThreadedSocketService *service,
                                                            GSocketConnection      *connection,
                                                            GObject                *source_object,
                                                            gpointer                user_data)          : Run Last

The ::run signal is emitted in a worker thread in response to an incoming connection. This thread is dedicated to handling `connection` and may perform blocking IO. The signal handler need not return until the connection is closed.

`service` : | the GThreadedSocketService.
`connection` : | a new GSocketConnection object.
`source_object` : | the source_object passed to `g_socket_listener_add_address()`.
`user_data` : | user data set when the signal handler was connected.
Returns : | `TRUE` to stope further signal handlers from being called

## See Also

GSocketService.